unit Setting;

interface
  //x̏o郆jbg interface  uses ̊ԂɈȉ̋Lq
  {$WARN UNIT_PLATFORM   OFF} //W1005 : for Filectrl
  {$WARN SYMBOL_DEPRECATED    OFF} //W1000 : for FileCtrl

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls,
  IniFiles, DecEdit, shlobj, ActiveX, plBrowseFolderEx;
const
  FORM_SETTING_WIDTH_SET  = 770;
  FORM_SETTING_HEIGHT_SET = 540;
  FORM_MAX                = 'MAX';
  FORM_MIN                = 'MIN';
  FORM_NORMAL             = 'NORMAL';

type
  TFormSetting = class(TForm)
    ButtonOK: TButton;
    ButtonCancel: TButton;

    Panel1: TPanel;
    Panel19: TPanel;
    PageControl1: TPageControl;
    TabSheet4: TTabSheet;
    Panel5: TPanel;
    Label9: TLabel;
    ButtonAnnsFM: TButton;
    Edit6: TEdit;
    plBrowseFolderEx1: TplBrowseFolderEx;

    procedure CreateParams(var Params: TCreateParams); override;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure ButtonOKClick(Sender: TObject);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonAnnsFMClick(Sender: TObject);

    procedure Edit6KeyPress(Sender: TObject; var Key: Char);

    function  ListFolderName(EditName: TEdit; Sender: TObject): String;
    function  SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;

  private
    { Private 錾 }
    StrFormState: String;
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;
    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;
    IntFormShiftX: Integer;
    IntFormShiftY: Integer;

    bButtomOK: Boolean;
    bButtomCancel: Boolean;
    bFormShow: Boolean;

  public
    { Public 錾 }

  end;

var
  FormSetting: TFormSetting;

implementation

uses
  Main;

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormSetting.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormSetting.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //j
  IniFile.Free;
  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormSetting.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  wRet1: Word;
  sStr2: String;
begin
  if (bButtomOK = FALSE) and (bButtomCancel = FALSE) then
  begin
    //mF
    sStr2 := 'ݒ肪ۑ܂񂪁A߂܂H';
    wRet1 := MessageDlg(sStr2, mtInformation, [mbYes, mbNo ], 0);
    //
    if wRet1 = mrYes then
    begin
      //
    end
    else
    begin
      //IȂ
      CanClose := FALSE;
    end;
  end;
end;

procedure TFormSetting.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //ݒ
  bButtomOK := FALSE;
  bButtomCancel := FALSE;
  PageControl1.TabStop := FALSE;

  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  FormPosLeft   := IniFile.ReadInteger('FormSetting', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormSetting', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormSetting', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormSetting', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormSetting', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;
  //j
  IniFile.Free;

end;

procedure TFormSetting.FormDestroy(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  //tH[
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormSetting', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormSetting', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormSetting', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormSetting', 'Left',   FormSetting.Left);
    IniFile.WriteInteger('FormSetting', 'Top',    FormSetting.Top);
    IniFile.WriteInteger('FormSetting', 'Width',  FormSetting.Width);
    IniFile.WriteInteger('FormSetting', 'Height', FormSetting.Height);
  end;
  //j
  IniFile.Free;

end;

procedure TFormSetting.FormResize(Sender: TObject);
begin
  Edit6.Width     := PageControl1.ClientWidth - 50;
end;

procedure TFormSetting.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormSetting.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);;
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);;
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormSetting.SetBounds(FormPosLeft + IntFormShiftX, FormPosTop + IntFormShiftY, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormSetting.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormSetting.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormSetting.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  Edit6.Text         := IniFile.ReadString ('AnnsFMFolder',    'Name',   '');
  //j
  IniFile.Free;

  //ݒ
  bFormShow := TRUE;

  //IMEIt
  SetImeMode(FormSetting.Handle, imClose);
end;

procedure TFormSetting.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    //̓LZ{^ɂȂ
    ModalResult := mrCancel;
  end
  else
  begin
    //
  end;
end;

procedure TFormSetting.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_SETTING_WIDTH_SET;
    y := FORM_SETTING_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormSetting.ButtonAnnsFMClick(Sender: TObject);
begin
//  Edit6.Text := ListFolderName(Edit6, Sender);
  plBrowseFolderEx1.InitDir := Edit6.Text;
  if plBrowseFolderEx1.Execute = TRUE then
  begin
    Edit6.Text := plBrowseFolderEx1.Directory + '\';
  end;
end;

procedure TFormSetting.ButtonCancelClick(Sender: TObject);
begin
  //ݒ
  bButtomCancel := TRUE;
  //I
  ModalResult := mrCancel;
end;

procedure TFormSetting.ButtonOKClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //
  if Edit6.Text = '' then
  begin
    showmessage('tH_ݒ肳Ă܂');
    Exit;
  end;
  //
  if Copy(Edit6.Text, Length(Edit6.Text), 1) <> '\' then
  begin
    Edit6.Text := Edit6.Text + '\';
  end;
  if DirectoryExists(Edit6.Text) = FALSE then
  begin
    showmessage('tH_݂܂');
    Exit;
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //ݒ
  IniFile.WriteString ('AnnsFMFolder',    'Name',   Edit6.Text);
  //j
  IniFile.Free;

  //ݒ
  bButtomOK := TRUE;
  //I
  ModalResult := mrOK;
end;

procedure TFormSetting.Edit6KeyPress(Sender: TObject; var Key: Char);
begin
  //Return
  if      key = #13 then
  begin
    //oȂ΍
    key := #0;
  end
  //Escape
  else if key = #27 then
  begin
    //oȂ΍
    key := #0;
  end
  else
  begin
    inherited KeyPress(Key);
  end;
end;

function TFormSetting.ListFolderName(EditName: TEdit; Sender: TObject): String;
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ
  if EditName.Text = '' then
  begin
    sStr2 := '';
  end
  else
  begin
    sStr2 := EditName.Text;
  end;
  if DirectoryExists(sStr2) = FALSE then
  begin
    sStr2 := '';
  end;
  if SelectDirectorySh('Select Directory', sStr2, sStr1) = TRUE then
  begin
    Result := sStr1;
    EditName.SetFocus;
  end
  else
  begin
    Result := EditName.Text;
    EditName.SetFocus;
  end;
end;

function TFormSetting.SelectDirectorySh(const Caption: string; const Root: string; out Directory: string): Boolean;
var
  FolderPidl : PItemIDList;
  BrowseInfo : TBrowseInfo;
  BPathName  : array[0..MAX_PATH-1] of Char;
  AMalloc    : IMalloc;
begin
  //
  Result := FALSE;
  //ڎʎq̂߂̃AP[Ṽ|C^擾
  ShGetMalloc(AMalloc);
  FolderPidl := nil;
  //
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.lpfn      := nil;
  BrowseInfo.lpszTitle := PChar('Select Directory');
  BrowseInfo.pidlRoot  := nil;
  BrowseInfo.ulFlags   := BIF_RETURNONLYFSDIRS or
                          BIF_NEWDIALOGSTYLE   or
                          BIF_VALIDATE;

//BIF_RETURNONLYFSDIRS   $0001 t@CVXefBNĝ݂I\
//BIF_DONTGOBELOWDOMAIN  $0002 hC̃lbg[NtH_\Ȃ
//BIF_STATUSTEXT         $0004 _CAOc[̂ɕ\
//                             R[obN֐ŏKv
//BIF_RETURNFSANCESTORS	 $0008 [gȉ̃t@CCtH_̂ݑI\
//BIF_EDITBOX            $0010 OҏWp{bNX\
//BIF_VALIDATE           $0020 OҏW{bNXւ̖ȕ`FbN
//                             BIF_EDITBOX ̎w肪鎞̂ݗL
//                             ̓R[obN֐ōs
//BIF_NEWDIALOGSTYLE	   $0040	ȉ̐VX^C̃_CAO\
//                             TCY\
//                             _CAOւ̃hbOAhhbv
//                             tH_̍Đ
//                             V[gJbgj[ (ReLXg)
//                             VtH_̍쐬
//BIF_USENEWUI           $0050 OҏW{bNX̂VX^C
//                             BIF_EDITBOX or BIF_NEWDIALOGSTYLE wƓ
//BIF_BROWSEINCLUDEURLS	 $0080 URL\\Ƃ
//                             BIF_USENEWUIBIF_BROWSEINCLUDEFILES ̎wKv
//                             YtH_T|[gꍇ̂ݕ\
//BIF_UAHINT             $0100 OҏW{bNX̑Ƀqg\
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NONEWFOLDERBUTTON  $0200  [VtH_̍쐬] {^\Ȃ
//                             BIF_NEWDIALOGSTYLE ̎wKv
//BIF_NOTRANSLATETARGETS $0400 IACeV[gJbg̏ꍇCNł͂ȂCV[gJbgg̍ڎʎqԂ
//BIF_BROWSEFORCOMPUTER  $1000 Rs[^̂ݑI\Ƃ
//BIF_BROWSEFORPRINTER   $2000 v^̂ݑI\Ƃ
//BIF_BROWSEINCLUDEFILES $4000 t@C\đI\Ƃ
//BIF_SHAREABLE          $8000 L\[X\đI\ɂ
//                             BIF_USENEWUI ̎wKv

  //̐ݒɊÂtH_Qƃ_CAO\
  try
    //擾
    FolderPidl := SHBrowseForFolder(BrowseInfo);
    If FolderPidl <> nil then
    begin
      //ڎʎqpX̕BPathNameɕϊ
      SHGetPathFromIDList(FolderPidl, BPathName);
      //
      Directory := BPathName;
      if Copy(Directory, Length(Directory), 1) <> '\' then
      begin
        Directory := Directory + '\';
      end;
      //
      Result := TRUE;
    end;
  finally
    //
    AMalloc.Free(FolderPidl);
  end;
end;

end.
