unit plBrowseFolderEx;

interface

uses
  SysUtils, Classes, Windows, Forms;

type
  //w\ȃIuV̗vf
  //IuVFNgCXyN^Ő݌vɐݒ\Ƃ邽ߒ`
  TplBrowseOp =(bifReturnOnlyFSDirs,
                bifDontGoBelowDomain,
                bifReturnFSAncestors,
                bifStatusText,
                bifEditBox,
                bifValidate,
                bifNewDialogStyle,
                bifUseNewUI,
                bifBrowseIncludeURLs,
                bifUAHint,
                bifNonNewFolderButton,
                bifNoTranslatetarGets,
                bifBrowseForComputer,
                bifBrowseForPrinter,
                bifBrowseIncludeFiles,
                bifShareable);

  //w\ȃIvVW
  //TplBrowsOptionEx͕I\ȏŴƂ
  TplBrowseOps = set of TplBrowseOp;

  TplBrowseFolderEx = class(TComponent)
  private
    { Private 錾 }
    FDirectory: String;
    FTitle          : String;
    FRootDir        : String;
    FRootSpecialDir : Integer;
    FInitDir        : String;
    FTop            : Integer;
    FLeft           : Integer;
    FOptions        : TplBrowseOps;
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    function Execute:Boolean;
    property Directory      : String read FDirectory;
    property RootDir        : String read FRootDir        write FRootDir;
    property RootSpecialDir : Integer read FRootSpecialDir write FRootSpecialDir;
    property InitDir        : String read FInitDir        write FInitDir;
    property Top            : Integer read FTop            write FTop;
    property Left           : Integer read FLeft           write FLeft;
  published
    { Published 錾 }
    property Title   : String      read FTitle   write FTitle;
    property Options : TplBrowseOps read FOptions write FOptions;
  end;

procedure Register;

implementation

uses ShlObj, ActiveX, Dialogs;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('Samples', [TplBrowseFolderEx]);
end;

{ TplBrowseFolderEx }

type
  PBFFRecord = ^TBFFRecord;
  TBFFRecord = record
  InitDir : PChar;
  X  : Integer;
  Y  : Integer;
end;

var
  APosX : Integer;
  APosY : Integer;
  //_CAO̊eIvVɑΉW^
  //VistaȊOŎgp邱ƂlĎlŒ`
  BrowseOptions: array [TplBrowseOp] of Integer=($0001, //BIF_RETURNONLYFSDIRS
                                                 $0002, //ȉ
                                                 $0004,
                                                 $0008,
                                                 $0010,
                                                 $0020,
                                                 $0040,
                                                 $0050,
                                                 $0080,
                                                 $0100,
                                                 $0200,
                                                 $0400,
                                                 $1000,
                                                 $2000,
                                                 $4000,
                                                 $8000);

//-----------------------------------------------------------------------------
//  tpXڎʎqɕϊ֐
//  tH_(CSIDLȊO)[gtH_Ŏw\Ȃ悤ɂ邽ߑ
//-----------------------------------------------------------------------------
function GetPItemIDFromFullPath(ShFolder:IShellFolder ;Path:String): PItemIDList;
var
  Len   : Cardinal;
  Flags : Cardinal;
begin
  Flags := 0;
  Len   := Length(Path);
  ShFolder.ParseDisplayName(Application.Handle,
                            nil,
                            PWideChar(StringToOleStr(Path)),
                            Len,
                            Result,
                            Flags);
end;

//=============================================================================
//  R|[lg̏
//=============================================================================
constructor TplBrowseFolderEx.Create(AOwner: TComponent);
begin
  inherited;

  //Ԃ̕\ʒu̓fXNgbv̐^
  FTop  := -1;
  FLeft := -1;
  FRootSpecialDir := CSIDL_DESKTOP;
  FOptions        := [bifReturnOnlyFSDirs];
end;

//-----------------------------------------------------------------------------
//  tH_[I_CAÕR[obN֐
//  \ʒu̖߂ĺCtH_IɈړl͖
//-----------------------------------------------------------------------------
function plBrowseExCallBack(hWindow: HWND; uMsg: UINT; lParam: LPARAM;
  lpData: LPARAM): Integer; stdcall;
var
  PBFFR     : PBFFRecord;
  ARect     : TRect;
  DlgWidth  : Integer;
  DlgHeight : Integer;
begin
  case uMsg of

  //_CAO̕\Jn
  BFFM_INITIALIZED:
    begin
      PBFFR := pointer(lpData);

      //ItH_łȂ΁CIԂɂ
      //ɂ̓_CAOEBhEBFFM_SETSELECTIONbZ[W𑗂
      if lstrlen(PBFFR^.InitDir) > 1 then begin
        SendMessage(hWindow, BFFM_SETSELECTION, 1, Integer(PBFFR^.InitDir));
      end;

      //\ʒu̐ݒ
      //ۂɂAPosX,APosY̓O[oϐȂ̂PBFFRoRȂĂ悢
      APosX := PBFFR^.X;
      APosY := PBFFR^.Y;
      //\w̍Wl-1łΉʂ̒ɕ\
      //łȂƎAPosXAPosYŎw肷l
      if (APosX < 0) and (APosY < 0) then begin
        GetWindowRect(hWindow, ARect);
        DlgWidth  := ARect.Right  - ARect.Left;
        DlgHeight := ARect.Bottom - ARect.Top;
        APosX := (GetSystemMetrics(SM_CXSCREEN) - DlgWidth) div 2;
        APosY := (GetSystemMetrics(SM_CYSCREEN) - DlgHeight) div 2;
      end else begin
      end;
      SetWindowPos(hWindow, 0, APosX, APosY, 0, 0, SWP_NOSIZE or SWP_NOZORDER);
    end;

  //tH_܂̓t@CIꂽ
  BFFM_SELCHANGED:
    begin
      //IɃ_CAÖʒu()擾邽߂ɃtH_Ix
      //̈ʒuĎ
      GetWindowRect(hWindow, ARect);
      APosX := ARect.Left;
      APosY := ARect.Top;
    end;
  end;
  //̃R[obN֐͏0ԂȂ΂Ȃ
  Result := 0;
end;

//=============================================================================
//  {R|̎s\bh
//  TOpenDialoĝ悤ExecuteƂĂ݂
//
//  {R|[lg̑SvpeB
//
//  Directory      Excute\bhs[OK]Ń_CAOɕԂ
//                 fBNg̃tpXDǏop
//   Title         _CAO㕔ɕ\^Cg
//  RootDir        [gtH_̎wDtH_ȊOw肷ꍇɐݒ
//  RootSpecialDir [gtH_̎wDtH_CSIDLlŎw肷
//                 RootDir̐ݒ肪D
//  InitDir        \JnɑItH_̃tpX
//                 tH_ł̎ẃC̃R|[lgł͕s
//  Top            _CAO̕\ʒu(YWl)DwȂ͉̎ʒ
//  Left           _CAO̕\ʒu(XWl)DwȂ͉̎ʒ
//  Options        \X^C̒lBIF_XXXXXŎw肷
//                 BIF_XXXXXɂusesShlObjKv
//=============================================================================
function TplBrowseFolderEx.Execute: Boolean;
var
  DesktopShFolder : IShellFolder;
  AFileDir        : String;
  BFFR            : TBFFRecord;
  IDList          : PItemIDList;
  BrowseInfo      : TBrowseInfo;
  Option          : TplBrowseOp;
  BPathName       : array[0..MAX_PATH-1] of Char;
  BDisplayName    : array[0..MAX_PATH-1] of Char;
  Malloc          : IMalloc;
begin
  Result := False;
  SHGetMalloc(Malloc);
  FillChar(BrowseInfo, SizeOf(BrowseInfo), #0);

  //RootDirvpeBłȂ͂[gƂ
  //łȂRootSepecialDirgp
  if FRootDir <> '' then begin
    //fXNgbṽVFtH_IuWFNg擾
    //VFł̓fXNgbv匳̃[gƂȂ
    SHGetDesktopFolder(DesktopSHFolder);
    //pĒʏ̃tpXڎʎqɕϊ
    IDList := GetPItemIDFromFullPath(DesktopShFolder, FRootDir);
  end else begin
    //CSIDLlڎʎqɕϊ
    SHGetSpecialFolderLocation(Application.Handle, FRootSpecialDir, IDList);
  end;

  AFileDir     := FInitDir;
  BFFR.InitDir := PChar(AFileDir);
  BFFR.X       := FLeft;
  BFFR.Y       := FTop;

  BrowseInfo.hwndOwner      := Application.Handle;
  BrowseInfo.pidlRoot       := IDList;
  BrowseInfo.pszDisplayName := BDisplayName;
  BrowseInfo.lpszTitle      := PChar(FTitle);
  BrowseInfo.lpfn           := Addr(plBrowseExCallBack);
  BrowseInfo.lParam         := Integer(Addr(BFFR));

  //IvV̐ݒ
  BrowseInfo.ulFlags := 0;
  for Option := Low(Option) to High(Option) do begin
    if Option in FOptions then begin
      BrowseInfo.ulFlags := BrowseInfo.ulFlags or Cardinal(BrowseOptions[Option]);
    end;
  end;

  IDList := SHBrowseForFolder(BrowseInfo);
  if IDList <> nil then begin
    //BrowseInfo.pszDisplayNameƃpXȂO
    SHGetPathFromIDList(IDList,
    Addr(BPathName));
    FLeft      := APosX;
    FTop       := APosY;
    Result     := True;
    FDirectory := BPathName;
    Malloc.Free(IDList);
  end;
end;

end.